<template>
<section class="column is-three-fifths is-offset-one-fifth">
   <h1 class="title"><strong>{{ $t("Bot.title") }}</strong></h1>
   <hr>
   <br />
   
   <section class="hero is-small is-info is-info is-bold">
   <div class="hero-body">
    <div class="container">
      <h1 class="subtitle">
       <strong>{{ $t('Bot.subtitle') }}</strong> 
      </h1>
      <h2>
         {{ $t('Bot.description') }}
      </h2>
    </div>
  </div>
</section>
<br />
<br />
  
   <section  class="hero is-small"  :class="$socket.connected ? 'is-success' : 'is-danger'">
      <div class="hero-body">
        <div class="container">
	   <h2>
             <span>{{ $socket.connected ? $t('Bot.connected') : $t('Bot.disconnected') }}</span>
           </h2>
	</div>
      </div>
   </section>

   <br />
        <b-message type="is-warning" v-if="userReadOnly">
	{{$t('Bot.sendMsg')}}
        </b-message>

   <br />
   <br />

   <section>
   <b-field :label="$t('form.username.label')" label-position="inside">
      <b-input :placeholder="$t('form.username.placeholder')"
	       type="string"
	       icon-pack="fas"
	       icon="user"
	       v-model="username"
	       v-bind:readonly="userReadOnly"
	       value=""></b-input>
    </b-field>

    <b-field v-if="!userReadOnly" class="is-pulled-right" horizontal><!-- Label left empty for spacing -->
      <p class="control">
        <button class="button is-primary" @click="onSubmit">{{ $t("form.submit") }}</button>
      </p>
    </b-field>
       <b-loading :is-full-page="true" :active.sync="isLoading" :can-cancel="true"></b-loading>
  </section>
  <br />
  <section>
  <div v-if="userReadOnly">
      <qrcode-vue :value="username" :size="300" level="L" class="q-mt-md"></qrcode-vue>
    <!--<ul id="example-1">
      <li v-for="message in messages" v-bind:key="message._id">
      	  {{ message._id }}
      </li>
    </ul>-->
    <br />
    <br />

    <p>{{messages.length + " " + $t('Bot.receivedMessages')}}</p>

    <br />
    <b-collapse
            class="card"
            v-for="message of messages"
            :key="message._id"
            :open="isOpen == index"
            @open="isOpen == index">
            <div
                slot="trigger"
                slot-scope="props"
                class="card-header"
                role="button">
                <p class="card-header-title">
                    {{ message.date | formatDate }}
                    {{ message._id + " " + message.from}}
                </p>
                <a class="card-header-icon">
                    <b-icon
                        :icon="props.open ? 'menu-down' : 'menu-up'">
                    </b-icon>
                </a>
            </div>
            <div class="card-content">
                <div class="content">
        <button class="button is-info is-large" @click="Decrypt(message._id)" :id="message._id" :value="message._id">
            <b-icon :icon="!message.locked ? 'lock-open' : 'lock'" size="is-large" type="is-white"></b-icon>
            <span>{{ !message.locked ? $t('Bot.lock') : $t('Bot.unlock') }}</span>
        </button>
        <br />
		     <p>{{$t('Bot.id')}}: {{message._id}} </p>
		     <p>{{$t('Bot.from')}}: {{message.from}} </p>
		     <p>{{$t('Bot.date')}}: {{message.date | formatDateItem }} </p>
		     <p>{{$t('Bot.payload')}}: <pre>{{message.msg}}</pre></p>
		     <p>{{$t('Bot.raw')}}</p>
		     <pre>{{message | pretty}}</pre>
                </div>
</div>
        </b-collapse>
    <!--<pre>{{messages | pretty}}</pre>-->
  </div>
  </section>
</section>
</template>

<script>
import { NotificationProgrammatic as Notification } from 'buefy'
var userRegisterEvent = "user:register";
var userLoginEvent = "user:login";
var userAuthEvent = "user:auth";
var messageReceiveEvent = "message:receive";
var messageSendEvent = "message:send";

var messageUploadEvent = "message:upload";

var userLockEvent = "user:lock";
var userUnlockEvent = "user:unlock";

var userDestroyEvent = "user:destroy";

var userDisconnectEvent = "disconnect";

const success = ":success";
const err = ":err";

import moment from 'moment'

import Vue from "vue";
import VueSocketIo from "vue-socket.io-extended";
import SocketIo from "socket.io-client";
import QrcodeVue from 'qrcode.vue';

var openpgp = require('openpgp'); // use as CommonJS, AMD, ES6 module or via window.openpgp


Vue.use(
    VueSocketIo,
    SocketIo(process.env.VUE_APP_API_APP, {
        autoConnect: false
    })
);


Vue.filter('formatDate', function(value) {
  if (value) {
    return moment(String(value), "YYYY-MM-DD'T'hh:mm:ss.SSS'Z'").calendar();
  }
})

Vue.filter('formatDateItem', function(value) {
  if (value) {
    return moment(String(value), "YYYY-MM-DD'T'hh:mm:ss.SSS'Z'").format('LLLL');
  }
})

export default Vue.extend({
    components: {
      QrcodeVue
    },
    data() {
     return {
      username: null,
      isLoading: false,
      privkey: null,
		  pubkey: null,
      userReadOnly: false,
      messages: [],
      isOpen: "false",
      index: ""
	    }
    },
    filters: {
      pretty: function(value) {
        //return JSON.stringify(JSON.parse(value), null, 2);
	return JSON.stringify(value, null, 2);
	}
    },
     created() {
        //this.$socket.client.connect();
	this.$socket.$subscribe(userRegisterEvent + err, payload => {
		this.isLoading = false;
		console.log("User Not Registered !");
		console.log(payload);
	});
	this.$socket.$subscribe(userRegisterEvent + success, payload => {
		this.isLoading = false;
		this.userReadOnly = true;
		this.username = payload.username;
		console.log("User Registered !");
		this.$socket.client.emit(userLoginEvent, this.username);
	});
	this.$socket.$subscribe(userLoginEvent, payload => {
		console.log(payload);
		console.log("Challenge Received !");
		console.log("Challenge Decrypted !");
		this.$socket.client.emit(userAuthEvent, "lol", this.username);
		console.log("Challenge Sent !");
	});
	this.$socket.$subscribe(userLoginEvent + err, payload => {
		console.log(payload);
	});
     	this.$socket.$subscribe(userAuthEvent + success, payload => {
		console.log("Challenge Authenticated !");
        });
	this.$socket.$subscribe(userAuthEvent + err, payload => {
		console.log(payload);
	});
        this.$socket.$subscribe("user:askauth", payload => {
		console.log("askauth");
		this.$socket.client.emit(userLoginEvent, this.username);
	});
	this.$socket.$subscribe(messageReceiveEvent, payload => {
    console.log(payload);
    payload = JSON.parse(payload);
    payload.locked = true;
    //payload["locked"] = true;
		this.messages.push(payload);
	});
   },
    sockets: {
       connect() {
         console.log('socket connected')
       },
       "err"(data) {
         console.log(data);
	 this.isLoading = false;
	 Notification.open({
                    duration: 5000,
                    message: data,
                    position: 'is-bottom-right',
                    type: 'is-danger',
                    hasIcon: true
                })
  	}
    },
    methods: {
          onSubmit (event) {
            this.isLoading = true;
            console.log(this.username);

            var options = {
              userIds: [{ name: "Jon Smith", email: "jon@example.com" }], // multiple user IDs
              rsaBits: 4096
              //curve: "curve25519" // ECC curve name
              //passphrase: 'super long and hard to guess secret'         // protects the private key
            };

            var self = this;
            openpgp.generateKey(options).then(function(key) {
              self.privkey = key.privateKeyArmored; // '-----BEGIN PGP PRIVATE KEY BLOCK ... '
              self.pubkey = key.publicKeyArmored; // '-----BEGIN PGP PUBLIC KEY BLOCK ... '
              //console.log(revocationCertificate)

              self.$socket.client.connect();
              self.$socket.client.emit(userRegisterEvent, self.username, self.pubkey);
            });
          },
  
      async Decrypt (event){
            var self = this
            console.log(event)
            var n = -1;
            for(var i = 0; i < this.messages.length; i++){
              console.log(this.messages[i]._id);
              if (this.messages[i]._id == event){
                n = i;
              }
            }
            if (this.messages[n].locked == false)
            {
               this.messages[n].locked = true;
               this.messages[n].msg = this.messages[n].encryptedMsg;
            }
            else{
              console.log(this.messages[n].locked)

              const privKeyObj = (await openpgp.key.readArmored(self.privkey)).keys[0]

              const options = {
                message: await openpgp.message.readArmored(self.messages[n].msg),    // parse armored message
                publicKeys: (await openpgp.key.readArmored(self.pubkey)).keys, // for verification (optional)
                privateKeys: [privKeyObj]                                 // for decryption
              }

            openpgp.decrypt(options).then(plaintext => {
                console.log(plaintext.data)
                self.messages[n].encryptedMsg = self.messages[n].msg;
                self.messages[n].msg = plaintext.data;
                self.messages[n].locked = false;
                //return plaintext.data // 'Hello, World!'
            })
            }
      }
    }
});

</script>
